package tp6;

// Classe abstraite implantant l'interface Iterateur

public abstract class Parcours implements Iterateur {
    protected TableauEntier tab;
    protected int posc;
    protected int posl;
    protected int nbEl;   

    public Parcours (TableauEntier tab){
	posc = posl = nbEl = 0;
	this.tab = tab;
    }
    public abstract void suivant();

    public boolean hasNext(){	
	return nbEl < tab.getWidth() * tab.getHeight();
    }
    public int next(){
	nbEl++;
	int i =  tab.valueAt(posl,posc);
	suivant();
	return i;

    }
}
