// 
//  Classe effectuant le parcours d'une collection en utilisant un iterator
// 
package tp6; 

import java.util.ArrayList ; 
import java.util.Iterator ; 

public class TestIterator {
   
    public static void main (String[] args) {
	if (args.length == 0) {
	    System.out.println("Usage: donner un entier (la taille du tableau)");
	    System.exit(1);
	}
	  
	int taille = Integer.parseInt(args[0]) ;

	// Creation et instanciation d'un ArrayList d'Integer
	ArrayList l  = new ArrayList();
	for (int i=0; i< taille; i++) 
	    l.add(new Integer(i)); 
	
       // Completer avec les instruction suivantes :
       // 1) Creer un objet Iterator avec la methode iterator()


       /* A VOUS DE JOUER */
	 
       // 2) Parcourir la  structure en utilisant les deux methodes
       //    hasNext() et next() de la classe Iterator
       //    On fera une boucle for ou une boucle while

       	System.out.println("version for");
	for (Iterator i = l.iterator(); i.hasNext();){
	    Integer integer = (Integer)i.next();
	    System.out.println(integer.intValue());
	}
	// ou


       	System.out.println("version for simplifiee java 5");
	for (Object integer: l){
	    System.out.println(((Integer)(integer)).intValue());
	}
	// ou
	System.out.println("version while");

	Iterator i = l.iterator();
	while (i.hasNext()){
	    Integer integer = (Integer)i.next();
	    System.out.println(integer.intValue());
	}
	//le warning de compilation
	// Note: tp6/TestIterator.java uses unchecked or unsafe operations.
	// Note: Recompile with -Xlint:unchecked for details.
	//provient du fait qu'on ne spcifie pas le type de l'arraylist avec la gnricit (Arraylist <Integer>)


       /* A VOUS DE JOUER */
       
    } // main

} //class 
 
